#
# blogch - ǼBlogޤBlogηǼ
#
# Copyright (c) 2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: Blogch.pm,v 1.8 2004/12/26 10:33:19 fuktommy Exp $
#
package Blogch;
use strict;

require Exporter;
use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);
@EXPORT = qw(
	encode decode escape escapeForm unescape
	date rfc822_time w3c_time args argsFromMulti
	list mon peep readFile writeFile stamp size stamp_cache search
	checkPasswd setPasswd cookie readNamedFile writeNamedFile
	attach writeAttach removeAttach jcode_convert
);

# ѿϸƽФ¦ꤹ뤳ȤꤷƤ
use vars qw($DATA_DIR $ATTACH_DIR $ART_LIMIT $STAMP_CACHE);
$DATA_DIR	= "./data";		# ǡ񤭹Ȥ
$ATTACH_DIR	= "./upload";		# źեե񤭹Ȥ
$ART_LIMIT	= 10240;		# 񤭹ߤκ祵(Bytes)
$STAMP_CACHE	= 5*24*60*60;		# 繹¸()

#
# lock
#
sub lock() {
	open LOCK, "> $DATA_DIR/lock";
	flock LOCK, 002;
}
sub unlock() {
	close LOCK;
}

#
# encode/decode
#
sub escape($) {
	local($_) = @_;
	s/&/&amp;/g;
	s/&amp;(#\d+|#[Xx][0-9A-Fa-f]+|[A-Za-z0-9]+);/&$1;/g;
	s/</&lt;/g;
	s/>/&gt;/g;
	s/"/&quot;/g;
	s/\r//g;
	return $_;
}
sub escapeForm($) {
	local($_) = @_;
	s/&(#\d+|#[Xx][0-9A-Fa-f]+|[A-Za-z0-9]+);/&amp;$1;/g;
	s/&amp;(gt|lt|amp|quot);/&$1;/g;
	return $_;
}
sub unescape($) {
	local($_) = @_;
	s/&lt;/</g;
	s/&gt;/>/g;
	s/&amp;/&/g;
	s/&quot;/"/g;
	return $_;
}
sub encode($) {		# Thanks for YukiWiki & WalWiki
	my($s) = @_;
	$s =~ s/[^-\w]/'%' . uc(unpack('H2', $&))/eg;
	return $s;
}
sub decode($) {		# Thanks for YukiWiki
	my($s) = @_;
	$s =~ s/\+/ /g;
	$s =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C", hex($1))/eg;
	return escape($s);
}

#
# 
#
sub rfc822_time($) {
	my @buf  = gmtime($_[0]);
	my @wday = qw(Sun Mon Tue Wed Thu Fri Sat);
	my @mon	 = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
	return sprintf "%s, %02d-%s-%d %02d:%02d:%02d GMT",
		       $wday[$buf[6]], $buf[3], $mon[$buf[4]], 1900+$buf[5], $buf[2], $buf[1], $buf[0];
}
sub w3c_time($) {
	my @buf  = gmtime($_[0]);
	return sprintf "%d-%02d-%02dT%02d:%02d:%02dZ",
		       1900+$buf[5], 1+$buf[4], $buf[3], $buf[2], $buf[1], $buf[0];
}
sub date(;$) {
	my($date) = @_;
	$date = time if (! defined $date);
	my (@date) = localtime($date);
	my %date = (
		seq   => $date[0],
		mim   => $date[1],
		hour  => $date[2],
		mday  => $date[3],
		mon   => sprintf("%02d", 1+$date[4]),
		year  => 1900 + $date[5],
		wday  => $date[6],
		yday  => $date[7],
		isdst => $date[8],
	);
	return %date;
}

#
# 
#
sub args($) {
	local $_ = $_[0];
	local @_ = split /&/;
	my %arg = ();
	foreach (@_) {
		local @_ = split /=/;
		if (defined $_[1]) {
			$arg{$_[0]} = decode($_[1]);
		} else {
			$arg{$_[0]} = "";
		}
	}
	if (keys %arg == 1) {
		my @k = keys %arg;
		if ($arg{$k[0]} eq "") {
			$arg{cmd} = "view";
			$arg{msg} = decode($k[0]);
		}
	}
	return %arg;	
}

#
# (multipart/form-data)
#
sub argsFromMulti($) {
	my($input) = @_;
	local $_;
	my %arg = ();
	$input =~ /\s/;
	my $boundary = $`;
	my @input = split $boundary, $input;
	shift @input;
	foreach (@input) {
		my @buf = split /\r\n/, $_;
		next if (@buf == 1);
		shift @buf;
		$buf[0] =~ /Content-Disposition: form-data; name="([^"]+)"/i or next;
		my $key = $1;

		if ($buf[0] =~ /filename="([^"]+)"/i) {
			$arg{auto_suffix} = $1;
			$arg{auto_suffix} =~ s/.*[\/\\]//;
			if ($arg{auto_suffix} =~ /\.([^.]*)$/) {
				$arg{auto_suffix} = $1;
				$arg{auto_suffix} = lc $arg{auto_suffix};
			} else {
				$arg{auto_suffix} = "";
			}
		}

		$_ = shift @buf until ((! defined $_) || ($_ eq ""));
		my $str = join "\r\n", @buf;
		if ($key eq "attach") {
			$arg{$key} = \$str;
		} else {
			$arg{$key} = escape($str);
		}
	}
	return %arg;
}


#
# źեե̾
#
sub attach($) {
	my($file) = @_;
	my @buf = glob "$ATTACH_DIR/$file*";
	if (@buf) {
		$buf[0] =~ s|$ATTACH_DIR/||;
		return $buf[0];
	} else {
		return undef;
	}
}

#
# źեեν񤭹
#
sub writeAttach($$) {
	my($file, $body) = @_;
	open OUT, "> $ATTACH_DIR/$file" or return undef;
	print OUT $body;
	close OUT;
	return 1;
}

#
# źեեκ
#
sub removeAttach($) {
	my($file) = @_;
	local $_;
	foreach (glob "$ATTACH_DIR/$file*") {
		unlink $_;
	}
}

#
# ե̾
#
sub file($) {
	my($file) = @_;
	my %date = date($file);
	return "$DATA_DIR/$date{year}$date{mon}/$file.txt";
}

#
# ե
#
sub list(;$$) {
	my($year, $mon) = @_;
	my $dir;
	if ($year) {
		$dir = "$DATA_DIR/$year$mon";
	} else {
		$dir = "$DATA_DIR/*";
	}
	my @page = glob "$dir/*.txt";
	local $_;
	foreach (@page) {
		/(\d+)\.txt$/;
		$_ = $1;
	}
	return @page;
}

#
# ΰ
#
sub mon() {
	my @dir = glob "$DATA_DIR/*";
	local $_;
	my @mon = ();
	foreach (@dir) {
		s|$DATA_DIR/||;
		next unless (/^\d+$/);
		/..$/;
		push @mon, {year=>$`, mon=>$&};
	}
	return @mon;
}

#
# 
#
sub stamp($) {
	my($file) = @_;
	my @stat = stat file($file);
	return $stat[9] || 0;
}

#
# 
#
sub size($) {
	my($file) = @_;
	return (-s file($file)) || 0;
}

#
# Υå
#
sub stamp_cache() {
	my %stamp = ();
	local $_;
	if (open IN, "$DATA_DIR/changes") {
		while (<IN>) {
			chomp;
			local @_ = split /<>/;
			$stamp{$_[1]} = $_[0];
		}
		close IN;
	}
	return %stamp;
}

#
# 省åι
#
sub updateCache(;$) {
	my($file) = @_;
	my %stamp = ();
	local $_;
	lock();
	if (open IN, "$DATA_DIR/changes") {
		while (<IN>) {
			chomp;
			local @_ = split /<>/;
			$stamp{$_[1]} = $_[0];
		}
		close IN;
	}
	if (defined $file) {
		my @stat = stat file($file);
		$stamp{$file} = $stat[9];
	}
	my $now = time;
	if (open OUT, "> $DATA_DIR/changes") {
		while (my($k, $v) = each %stamp) {
			if (($v >= $now - $STAMP_CACHE) && (-f file($k))) {
				print OUT "$v<>$k\n" 
			}
		}
	}
	unlock();
}

#
# ե1ܤɽ
#
sub peep($) {
	my($file) = @_;
	local $_;
	if (open IN, file($file)) {
		$_ = <IN>;
		close IN;
		chomp;
		return $_;
	} else {
		return undef;
	}
}

#
# եȤɽ
#
sub _readFile($;$) {
	my($file, $size) = @_;
	if (open IN, $file) {
		local $_;
		my @buf = ();
		my $i=0;
		while (<IN>) {
			chomp;
			$_ = escape($_);
			push @buf, $_;
			last if ($size && ($i++ >= $size));
		}
		close IN;
		return @buf;
	} else {
		return ();
	}
}
sub readFile($;$) {
	return _readFile(file($_[0]), $_[1]);
}
sub readNamedFile($) {
	return _readFile("$DATA_DIR/$_[0]");
}

#
# ե˽񤭹
# $opt{stamp}, $opt{mode}
#
sub _writeFile($$$) {
	my($file, $message, $mode) = @_;
	$message = unescape($message);
	lock();
	if (open OUT, $mode . $file) {
		print OUT $message;
		close OUT;
		unlock();
		return 1;
	} else {
		unlock();
		return undef;
	}
}
sub writeFile($$;$%) {
	my($file, $message, %opt) = @_;
	if ($opt{stamp} && (stamp($file) > $opt{stamp})) {
		return undef;
	}
	my %date = date($file);
	my $dir	 = "$DATA_DIR/$date{year}$date{mon}";
	if ($message eq "") {
		unlink file($file);
		rmdir $dir;
		removeAttach($file);
		updateCache();
		return 1;
	}
	my $mode = ($opt{mode})? $opt{mode}: ">";
	my $size = ($mode =~ />>/)? (-s file($file))+length($message): length($message);
	if ($size > $ART_LIMIT) {
		return undef;
	}
	mkdir $dir, 0777 unless (-d $dir);
	my $stat = _writeFile(file($file), $message, $mode);
	updateCache($file);
	return $stat;
}
sub writeNamedFile($$) {
	my($file, $message) = @_;
	return _writeFile("$DATA_DIR/$file", $message, ">");
}

#
# 
#
sub search($) {
	my($query) = @_;
	my $file;
	my %result = ();
	foreach $file (glob("$DATA_DIR/*/*.txt")) {
		my $file2 = $file;
		$file2 =~ /(\d+)\.txt/;
		$file2 = $1;
		my $found;
		open IN, $file or next;
		my @buf = <IN>;
		foreach (@buf) {
			if (/\Q$query\E/i) {
				$found = 1;
				last;
			}
		}
		close IN;
		if ($found) {
			chomp $buf[0];
			$result{$file2} = $buf[0];
		}
	}
	return %result;
}

#
# ѥɤ
#
sub setPasswd($) {
	my($passwd) = @_;
	lock();
	open OUT, "> $DATA_DIR/passwd";
	print OUT crypt($passwd, sprintf("%02X", 256*rand));
	unlock();
}

#
# ѥɤĴ٤
#
sub checkPasswd($) {
	my($passwd) = @_;
	open IN, "$DATA_DIR/passwd" or return 1;
	local $_ = <IN>;
	close IN;
	return $_ eq crypt $passwd, $_;
}

#
# åɤ߹
#
sub cookie($) {
	my($str) = @_;
	if (defined $str) {
		my %cookie;
		my @buf = split /;\s*/, $ENV{HTTP_COOKIE};
		local $_;
		foreach (@buf) {
			my @b = split /=/, $_, 2;
			$cookie{$b[0]} = $b[1];
		}
		return %cookie;
	} else {
		return ();
	}
}

#
# ʸɤѴ
#
sub jcode_convert(%) {
	use Jcode;
	my(%opt) = @_;
	local $_;
	foreach (keys %opt) {
		if ($opt{charset} =~ /UTF-?8/i) {
			$opt{$_} = Jcode->new($opt{$_}, "utf8")->euc;
		} elsif ($opt{charset} =~ /SHIFT_JIS/i) {
			$opt{$_} = Jcode->new($opt{$_}, "sjis")->euc;
		} elsif ($opt{charset} =~ /EUC-JP/i) {
			$opt{$_} = Jcode->new($opt{$_}, "euc")->euc;
		} elsif ($opt{charset} =~ /ISO-2022-JP/i) {
			$opt{$_} = Jcode->new($opt{$_}, "jis")->euc;
		} else {
			$opt{$_} = Jcode->new($opt{$_})->euc;
		}
	}
	return %opt;
}

1;
